//---------------------------------------------------------------------
#include "MainWindow.h"
//---------------------------------------------------------------------
int32 rec_thread(void *Dummy)
{
    int sock;
    BWindow *Owner;
    struct timeval tv;
    struct fd_set fds;
    BMessage *sendmsg;
    unsigned char buf[1024];
    ssize_t rec;
    RecThreadData rdata;
    int32 sender;
    int32 code;	

    code=receive_data((thread_id *)&sender,(void *)&rdata,sizeof(rdata));
    Owner=rdata.owner;
    sock=rdata.sock;
	
    do{
        do{
            tv.tv_sec=2;
            tv.tv_usec=0;
            FD_ZERO(&fds);
	        FD_SET(sock,&fds);
            select(32,&fds,NULL,NULL,&tv);
        } while(FD_ISSET(sock,&fds)==0);

       	rec=recv(sock,buf,sizeof(buf),0);
        if(rec<=0)
        {
            sendmsg=new BMessage(MSG_CLOSED);
            sendmsg->AddInt32("socket",sock);
			
            Owner->PostMessage(sendmsg);
            delete sendmsg;	
        }
        else
        {
            sendmsg=new BMessage(MSG_RECV);
            sendmsg->AddInt32("socket",sock);
            sendmsg->AddData("data",B_ANY_TYPE,(void *)buf,rec);

            Owner->PostMessage(sendmsg);
            delete sendmsg;	
        }
    } while(rec>0);

    return rec;
}
//---------------------------------------------------------------------
BAppMainWindow::BAppMainWindow(BRect frame,const char *title)
    :BWindow(frame,title,MAINWINDOW_WINDOWSTYLE,0)
{
    mainview=new BAppMainView(Bounds());	
    AddChild(mainview);

    nsock=-1;
    strcpy(threadname,"");
}
//---------------------------------------------------------------------
void BAppMainWindow::MessageReceived(BMessage *msg)
{
    switch(msg->what)
    {
        case MSG_SEND:
            sock_send();
            break;
        case MSG_CONNECT:
            sock_connect();
            break;
        case MSG_LISTEN:
            sock_listen();
            break;
        case MSG_CLOSED:
            sock_closed();
            break;
        case MSG_RECV:
            {
                char *buf;
                ssize_t leng;
				
                msg->FindData("data",B_ANY_TYPE,(const void **)&buf,&leng);

                mainview->strview->SetText(buf);
            }
            break;
        default:
            BWindow::MessageReceived(msg);
    }
}
//---------------------------------------------------------------------
BAppMainView::BAppMainView(BRect frame)
    :BView(frame,"bappmainview",B_FOLLOW_ALL,B_WILL_DRAW)
{
    BRect viewrect(Bounds());
    connectbtn=new BButton(BRect(viewrect.right-144,8,
                                 viewrect.right-80,28),"connectbtn",
                                 "Connect",new BMessage(MSG_CONNECT),
	                             B_FOLLOW_RIGHT | B_FOLLOW_TOP);
    AddChild(connectbtn);
    listenbtn=new BButton(BRect(viewrect.right-72,8,
                                viewrect.right-8,28),"listenbtn",
                                "Listen",new BMessage(MSG_LISTEN),
                                B_FOLLOW_RIGHT | B_FOLLOW_TOP);
    AddChild(listenbtn);
    sendbtn=new BButton(BRect(viewrect.right-72,98,
                              viewrect.right-8,118),"sendbtn",
                              "Send",new BMessage(MSG_SEND),
                              B_FOLLOW_RIGHT | B_FOLLOW_TOP);
    AddChild(sendbtn);

    textctrl=new BTextControl(BRect(8,38,viewrect.right-8,58),"textctrl",
                              NULL,"Default",NULL,
                              B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP);
    AddChild(textctrl);

    strview=new BStringView(BRect(8,68,viewrect.right-8,88),"strview",
                            "NoData",
                            B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP);
    AddChild(strview);

    textctrl->SetEnabled(false);
    sendbtn->SetEnabled(false);
}
//---------------------------------------------------------------------
void BAppMainWindow::sock_connect(void)
{
    struct sockaddr_in sa;
    int r;
	
    mainview->connectbtn->SetEnabled(false);
    mainview->listenbtn->SetEnabled(false);

    nsock=socket(AF_INET, SOCK_STREAM, 0);
    sa.sin_family=AF_INET;
    sa.sin_port=htons(10000);
    sa.sin_addr.s_addr=inet_addr("127.0.0.1");
    memset(sa.sin_zero,0,sizeof(sa.sin_zero));
    r=connect(nsock,(struct sockaddr *)&sa,sizeof(sa));

    if(r!=-1)
    {
		struct RecThreadData rdata;
		
		mainview->strview->SetText("Connect");	
		mainview->textctrl->SetEnabled(true);
		mainview->sendbtn->SetEnabled(true);

		rdata.sock=nsock;
		rdata.owner=(BWindow *)this;
		strcpy(threadname,"ClientRecvThread");
		recthread=spawn_thread(rec_thread,threadname,
		                    B_NORMAL_PRIORITY,NULL);
		send_data(recthread,63,(void *)&rdata,sizeof(rdata));
		resume_thread(recthread); 
	}
}
//---------------------------------------------------------------------
void BAppMainWindow::sock_listen(void)
{
    int ssock;
	struct sockaddr_in sa;
	int sa_size;
    
	mainview->connectbtn->SetEnabled(false);
	mainview->listenbtn->SetEnabled(false);

	ssock=socket(AF_INET,SOCK_STREAM,0);

    sa.sin_family=AF_INET;
    sa.sin_port=htons(10000);
    sa.sin_addr.s_addr=INADDR_ANY;
    memset(sa.sin_zero,0,sizeof(sa.sin_zero));
    bind(ssock,(struct sockaddr *)&sa,sizeof(sa)); 
	listen(ssock,5);
	sa_size=sizeof(sa);
	nsock=accept(ssock,(struct sockaddr *)&sa, &sa_size); 
    closesocket(ssock);

	if(nsock!=-1)
	{
		struct RecThreadData rdata;
		
		mainview->strview->SetText("Connect");	
		mainview->textctrl->SetEnabled(true);
		mainview->sendbtn->SetEnabled(true);

		rdata.sock=nsock;
		rdata.owner=(BWindow *)this;
		strcpy(threadname,"ServerRecvThread");
		recthread=spawn_thread(rec_thread,threadname,
		                    B_NORMAL_PRIORITY,NULL);
		send_data(recthread,63,(void *)&rdata,sizeof(rdata));
		resume_thread(recthread); 
	}
}
//---------------------------------------------------------------------
void BAppMainWindow::sock_send(void)
{
	int r;
	
	r=send(nsock,mainview->textctrl->Text(),
	     strlen(mainview->textctrl->Text())+1,0);
	if(r==-1)
	{
		closesocket(nsock);
		nsock=-1;
		mainview->strview->SetText("Disconnect");
	}
}
//---------------------------------------------------------------------
bool BAppMainWindow::QuitRequested()
{
	sock_closed();
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
};
//---------------------------------------------------------------------
void BAppMainWindow::sock_closed(void)
{
	int32 fthread;
	
    if(nsock!=-1)
    {
    	closesocket(nsock);
    	if(strlen(threadname)>0)
    		if((fthread=find_thread(threadname))!=B_NAME_NOT_FOUND)	
    			kill_thread(fthread);
    }
};
//---------------------------------------------------------------------
